diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/wifi/test/wifi-mlo-test.cc ns-3.43/src/wifi/test/wifi-mlo-test.cc
--- ns-3.42/src/wifi/test/wifi-mlo-test.cc	2024-05-29 15:29:47.220074000 -0700
+++ ns-3.43/src/wifi/test/wifi-mlo-test.cc	2024-10-09 16:41:10.136656800 -0700
@@ -1626,26 +1433,37 @@
                               true,
                               "STA " << staAddr << " not found in list of associated STAs");
 
-        // STA of non-AP MLD operate on the same channel as the AP
-        NS_TEST_EXPECT_MSG_EQ(
-            +m_staMacs[0]->GetWifiPhy(staLinkId)->GetOperatingChannel().GetNumber(),
-            +m_apMac->GetWifiPhy(apLinkId)->GetOperatingChannel().GetNumber(),
-            "Incorrect operating channel number for STA on link " << +staLinkId);
-        NS_TEST_EXPECT_MSG_EQ(
-            m_staMacs[0]->GetWifiPhy(staLinkId)->GetOperatingChannel().GetFrequency(),
-            m_apMac->GetWifiPhy(apLinkId)->GetOperatingChannel().GetFrequency(),
-            "Incorrect operating channel frequency for STA on link " << +staLinkId);
-        NS_TEST_EXPECT_MSG_EQ(m_staMacs[0]->GetWifiPhy(staLinkId)->GetOperatingChannel().GetWidth(),
-                              m_apMac->GetWifiPhy(apLinkId)->GetOperatingChannel().GetWidth(),
+        // STA of non-AP MLD operate on the same channel as the AP (or on its primary80 if the AP
+        // operates on a 160 MHz channel and non-AP MLD does not support 160 MHz operations)
+        const auto& staChannel = m_staMacs[0]->GetWifiPhy(staLinkId)->GetOperatingChannel();
+        const auto& apChannel = m_apMac->GetWifiPhy(apLinkId)->GetOperatingChannel();
+
+        auto width = apChannel.GetTotalWidth();
+        auto primary20 = apChannel.GetPrimaryChannelIndex(20);
+
+        if (width > 80 && !m_support160MHzOp)
+        {
+            width = 80;
+            primary20 -= apChannel.GetPrimaryChannelIndex(80) * 4;
+        }
+
+        NS_TEST_EXPECT_MSG_EQ(+staChannel.GetNumber(),
+                              +apChannel.GetPrimaryChannelNumber(width, WIFI_STANDARD_80211be),
+                              "Incorrect operating channel number for STA on link " << +staLinkId);
+        NS_TEST_EXPECT_MSG_EQ(staChannel.GetFrequency(),
+                              apChannel.GetPrimaryChannelCenterFrequency(width),
+                              "Incorrect operating channel frequency for STA on link "
+                                  << +staLinkId);
+        NS_TEST_EXPECT_MSG_EQ(staChannel.GetWidth(),
+                              width,
                               "Incorrect operating channel width for STA on link " << +staLinkId);
-        NS_TEST_EXPECT_MSG_EQ(
-            +m_staMacs[0]->GetWifiPhy(staLinkId)->GetOperatingChannel().GetPhyBand(),
-            +m_apMac->GetWifiPhy(apLinkId)->GetOperatingChannel().GetPhyBand(),
-            "Incorrect operating PHY band for STA on link " << +staLinkId);
-        NS_TEST_EXPECT_MSG_EQ(
-            +m_staMacs[0]->GetWifiPhy(staLinkId)->GetOperatingChannel().GetPrimaryChannelIndex(20),
-            +m_apMac->GetWifiPhy(apLinkId)->GetOperatingChannel().GetPrimaryChannelIndex(20),
-            "Incorrect operating primary channel index for STA on link " << +staLinkId);
+        NS_TEST_EXPECT_MSG_EQ(+staChannel.GetPhyBand(),
+                              +apChannel.GetPhyBand(),
+                              "Incorrect operating PHY band for STA on link " << +staLinkId);
+        NS_TEST_EXPECT_MSG_EQ(+staChannel.GetPrimaryChannelIndex(20),
+                              +primary20,
+                              "Incorrect operating primary channel index for STA on link "
+                                  << +staLinkId);
     }
 
     // lambda to check the link mapping stored at wifi MAC
@@ -1667,6 +1485,23 @@
                     "Incorrect link mapping stored by "
                         << (mac->GetTypeOfStation() == AP ? "AP" : "non-AP") << " MLD for " << dir
                         << " direction");
+
+                // check correctness of WifiMac::TidMappedOnLink function
+                std::set<uint8_t> setupLinks(m_setupLinks.cbegin(), m_setupLinks.cend());
+                for (uint8_t tid = 0; tid < 8; ++tid)
+                {
+                    const auto& linkSet = mapping.contains(tid) ? mapping.at(tid) : setupLinks;
+
+                    for (const auto linkId : setupLinks)
+                    {
+                        NS_TEST_EXPECT_MSG_EQ(
+                            mac->TidMappedOnLink(dest->GetAddress(), dir, tid, linkId),
+                            linkSet.contains(linkId),
+                            "Incorrect return value on " << (mac == m_apMac ? "AP" : "STA")
+                                                         << " direction " << dir << " TID " << +tid
+                                                         << " linkID " << +linkId);
+                    }
+                }
             }
         };
 
@@ -1726,20 +1561,30 @@
 }
 
 void
-MultiLinkSetupTest::CheckQosData(Ptr<WifiMpdu> mpdu, uint8_t linkId, std::size_t index)
+MultiLinkSetupTest::CheckQosData(Ptr<WifiMpdu> mpdu,
+                                 const WifiTxVector& txvector,
+                                 uint8_t linkId,
+                                 std::size_t index)
 {
     WifiDirection dir;
     const auto& hdr = mpdu->GetHeader();
 
     NS_TEST_ASSERT_MSG_EQ(hdr.IsQosData(), true, "Expected a QoS data frame");
 
+    // check TX width
+    // STA of non-AP MLD operate on the same channel as the AP (or on its primary80 if the AP
+    // operates on a 160 MHz channel and non-AP MLD does not support 160 MHz operations)
+    MHz_u width;
+
     if (!hdr.IsToDs() && hdr.IsFromDs())
     {
         dir = WifiDirection::DOWNLINK;
+        width = m_apMac->GetWifiPhy(linkId)->GetOperatingChannel().GetTotalWidth();
     }
     else if (hdr.IsToDs() && !hdr.IsFromDs())
     {
         dir = WifiDirection::UPLINK;
+        width = m_staMacs[0]->GetWifiPhy(linkId)->GetOperatingChannel().GetTotalWidth();
     }
     else
     {
@@ -1747,6 +1592,12 @@
                                                                      << hdr.IsFromDs() << ")");
     }
 
+    if (width > 80 && !m_support160MHzOp)
+    {
+        width = 80;
+    }
+    NS_TEST_EXPECT_MSG_EQ(txvector.GetChannelWidth(), width, "Unexpected TX width");
+
     const auto& tid1 = (dir == WifiDirection::DOWNLINK) ? m_dlTid1 : m_ulTid1;
     const auto& tid2 = (dir == WifiDirection::DOWNLINK) ? m_dlTid2 : m_ulTid2;
     uint8_t tid = hdr.GetQosTid();
@@ -1865,124 +1716,6 @@
     }
 }
 
-/**
- * Tested traffic patterns.
- */
-enum class WifiTrafficPattern : uint8_t
-{
-    STA_TO_STA = 0,
-    STA_TO_AP,
-    AP_TO_STA,
-    AP_TO_BCAST,
-    STA_TO_BCAST
-};
-
-/**
- * Block Ack agreement enabled/disabled
- */
-enum class WifiBaEnabled : uint8_t
-{
-    NO = 0,
-    YES
-};
-
-/**
- * Whether to send a BlockAckReq after a missed BlockAck
- */
-enum class WifiUseBarAfterMissedBa : uint8_t
-{
-    NO = 0,
-    YES
-};
-
-/**
- * \ingroup wifi-test
- * \ingroup tests
- *
- * \brief Test data transmission between two MLDs.
- *
- * This test sets up an AP MLD and two non-AP MLDs having a variable number of links.
- * The RF channels to set each link to are provided as input parameters through the test
- * case constructor, along with the identifiers (starting at 0) of the links that cannot
- * switch PHY band (if any). This test aims at veryfing the successful transmission of both
- * unicast QoS data frames (from one station to another, from one station to the AP, from
- * the AP to the station) and broadcast QoS data frames (from the AP or from one station).
- * In the scenarios in which the AP forwards frames (i.e., from one station to another and
- * from one station to broadcast) the client application generates only 4 packets, in order
- * to limit the probability of collisions. In the other scenarios, 8 packets are generated.
- * When BlockAck agreements are enabled, the maximum A-MSDU size is set such that two
- * packets can be aggregated in an A-MSDU. The MPDU with sequence number equal to 1 is
- * corrupted (once, by using a post reception error model) to test its successful
- * re-transmission, unless the traffic scenario is from the AP to broadcast (broadcast frames
- * are not retransmitted) or is a scenario where the AP forwards frame (to limit the
- * probability of collisions).
- *
- * When BlockAck agreements are enabled, we also corrupt a BlockAck frame, so as to simulate
- * the case of BlockAck timeout. Both the case where a BlockAckReq is sent and the case where
- * data frame are retransmitted are tested. Finally, when BlockAck agreements are enabled, we
- * also enable the concurrent transmission of data frames over two links and check that at
- * least one MPDU is concurrently transmitted over two links.
- */
-class MultiLinkTxTest : public MultiLinkOperationsTestBase
-{
-  public:
-    /**
-     * Constructor
-     *
-     * \param baseParams common configuration parameters
-     * \param trafficPattern the pattern of traffic to generate
-     * \param baEnabled whether BA agreement is enabled or disabled
-     * \param useBarAfterMissedBa whether a BAR or Data frames are sent after missed BlockAck
-     * \param nMaxInflight the max number of links on which an MPDU can be simultaneously inflight
-     *                     (unused if Block Ack agreements are not established)
-     */
-    MultiLinkTxTest(const BaseParams& baseParams,
-                    WifiTrafficPattern trafficPattern,
-                    WifiBaEnabled baEnabled,
-                    WifiUseBarAfterMissedBa useBarAfterMissedBa,
-                    uint8_t nMaxInflight);
-    ~MultiLinkTxTest() override = default;
-
-  protected:
-    /**
-     * Check the content of a received BlockAck frame when the max number of links on which
-     * an MPDU can be inflight is one.
-     *
-     * \param psdu the PSDU containing the BlockAck
-     * \param txVector the TXVECTOR used to transmit the BlockAck
-     * \param linkId the ID of the link on which the BlockAck was transmitted
-     */
-    void CheckBlockAck(Ptr<const WifiPsdu> psdu, const WifiTxVector& txVector, uint8_t linkId);
-
-    void Transmit(Ptr<WifiMac> mac,
-                  uint8_t phyId,
-                  WifiConstPsduMap psduMap,
-                  WifiTxVector txVector,
-                  double txPowerW) override;
-    void DoSetup() override;
-    void DoRun() override;
-
-  private:
-    void StartTraffic() override;
-
-    /// Receiver address-indexed map of list error models
-    using RxErrorModelMap = std::unordered_map<Mac48Address, Ptr<ListErrorModel>, WifiAddressHash>;
-
-    RxErrorModelMap m_errorModels;       ///< error rate models to corrupt packets
-    std::list<uint64_t> m_uidList;       ///< list of UIDs of packets to corrupt
-    bool m_dataCorrupted{false};         ///< whether second data frame has been already corrupted
-    WifiTrafficPattern m_trafficPattern; ///< the pattern of traffic to generate
-    bool m_baEnabled;                    ///< whether BA agreement is enabled or disabled
-    bool m_useBarAfterMissedBa;          ///< whether to send BAR after missed BlockAck
-    std::size_t m_nMaxInflight;          ///< max number of links on which an MPDU can be inflight
-    std::size_t m_nPackets;              ///< number of application packets to generate
-    std::size_t m_blockAckCount{0};      ///< transmitted BlockAck counter
-    std::size_t m_blockAckReqCount{0};   ///< transmitted BlockAckReq counter
-    std::map<uint16_t, std::size_t> m_inflightCount; ///< seqNo-indexed max number of simultaneous
-                                                     ///< transmissions of a data frame
-    Ptr<WifiMac> m_sourceMac; ///< MAC of the node sending application packets
-};
-
 MultiLinkTxTest::MultiLinkTxTest(const BaseParams& baseParams,
                                  WifiTrafficPattern trafficPattern,
                                  WifiBaEnabled baEnabled,
@@ -2450,105 +2183,6 @@
     Simulator::Destroy();
 }
 
-/**
- * Tested MU traffic patterns.
- */
-enum class WifiMuTrafficPattern : uint8_t
-{
-    DL_MU_BAR_BA_SEQUENCE = 0,
-    DL_MU_MU_BAR,
-    DL_MU_AGGR_MU_BAR,
-    UL_MU
-};
-
-/**
- * \ingroup wifi-test
- * \ingroup tests
- *
- * \brief Test data transmission between MLDs using OFDMA MU transmissions
- *
- * This test sets up an AP MLD and two non-AP MLDs having a variable number of links.
- * The RF channels to set each link to are provided as input parameters through the test
- * case constructor, along with the identifiers (starting at 0) of the links that cannot
- * switch PHY band (if any). This test aims at veryfing the successful transmission of both
- * DL MU and UL MU frames. In the DL MU scenarios, the client applications installed on the
- * AP generate 8 packets addressed to each of the stations (plus 3 packets to trigger the
- * establishment of BlockAck agreements). In the UL MU scenario, client applications
- * installed on the stations generate 4 packets each (plus 3 packets to trigger the
- * establishment of BlockAck agreements).
- *
- * The maximum A-MSDU size is set such that two packets can be aggregated in an A-MSDU.
- * The MPDU with sequence number equal to 3 is corrupted (by using a post reception error
- * model) once and for a single station, to test its successful re-transmission.
- *
- * Also, we enable the concurrent transmission of data frames over two links and check that at
- * least one MPDU is concurrently transmitted over two links.
- */
-class MultiLinkMuTxTest : public MultiLinkOperationsTestBase
-{
-  public:
-    /**
-     * Constructor
-     *
-     * \param baseParams common configuration parameters
-     * \param muTrafficPattern the pattern of traffic to generate
-     * \param useBarAfterMissedBa whether a BAR or Data frames are sent after missed BlockAck
-     * \param nMaxInflight the max number of links on which an MPDU can be simultaneously inflight
-     *                     (unused if Block Ack agreements are not established)
-     */
-    MultiLinkMuTxTest(const BaseParams& baseParams,
-                      WifiMuTrafficPattern muTrafficPattern,
-                      WifiUseBarAfterMissedBa useBarAfterMissedBa,
-                      uint8_t nMaxInflight);
-    ~MultiLinkMuTxTest() override = default;
-
-  protected:
-    /**
-     * Check the content of a received BlockAck frame when the max number of links on which
-     * an MPDU can be inflight is one.
-     *
-     * \param psdu the PSDU containing the BlockAck
-     * \param txVector the TXVECTOR used to transmit the BlockAck
-     * \param linkId the ID of the link on which the BlockAck was transmitted
-     */
-    void CheckBlockAck(Ptr<const WifiPsdu> psdu, const WifiTxVector& txVector, uint8_t linkId);
-
-    void Transmit(Ptr<WifiMac> mac,
-                  uint8_t phyId,
-                  WifiConstPsduMap psduMap,
-                  WifiTxVector txVector,
-                  double txPowerW) override;
-    void DoSetup() override;
-    void DoRun() override;
-
-  private:
-    void StartTraffic() override;
-
-    /// Receiver address-indexed map of list error models
-    using RxErrorModelMap = std::unordered_map<Mac48Address, Ptr<ListErrorModel>, WifiAddressHash>;
-
-    /// A pair of a MAC address (the address of the receiver for DL frames and the address of
-    /// the sender for UL frames) and a sequence number identifying a transmitted QoS data frame
-    using AddrSeqNoPair = std::pair<Mac48Address, uint16_t>;
-
-    RxErrorModelMap m_errorModels;                  ///< error rate models to corrupt packets
-    std::list<uint64_t> m_uidList;                  ///< list of UIDs of packets to corrupt
-    std::optional<Mac48Address> m_dataCorruptedSta; ///< MAC address of the station that received
-                                                    ///< MPDU with SeqNo=2 corrupted
-    bool m_waitFirstTf{true}; ///< whether we are waiting for the first Basic Trigger Frame
-    WifiMuTrafficPattern m_muTrafficPattern; ///< the pattern of traffic to generate
-    bool m_useBarAfterMissedBa;              ///< whether to send BAR after missed BlockAck
-    std::size_t m_nMaxInflight; ///< max number of links on which an MPDU can be inflight
-    std::vector<PacketSocketAddress> m_sockets; ///< packet socket addresses for STAs
-    std::size_t m_nPackets;                     ///< number of application packets to generate
-    std::size_t m_blockAckCount{0};             ///< transmitted BlockAck counter
-    std::size_t m_tfCount{0};                   ///< transmitted Trigger Frame counter
-    // std::size_t m_blockAckReqCount{0};     ///< transmitted BlockAckReq counter
-    std::map<AddrSeqNoPair, std::size_t> m_inflightCount; ///< max number of simultaneous
-                                                          ///< transmissions of each data frame
-    Ptr<WifiMac> m_sourceMac; ///< MAC of the node sending application packets
-};
-
 MultiLinkMuTxTest::MultiLinkMuTxTest(const BaseParams& baseParams,
                                      WifiMuTrafficPattern muTrafficPattern,
                                      WifiUseBarAfterMissedBa useBarAfterMissedBa,
@@ -3060,48 +2694,6 @@
     Simulator::Destroy();
 }
 
-/**
- * \ingroup wifi-test
- * \ingroup tests
- *
- * \brief Test release of sequence numbers upon CTS timeout in multi-link operations
- *
- * In this test, an AP MLD and a non-AP MLD setup 3 links. Usage of RTS/CTS protection is
- * enabled for frames whose length is at least 1000 bytes. The AP MLD receives a first set
- * of 4 packets from the upper layer and sends an RTS frame, which is corrupted at the
- * receiver, on a first link. When the RTS frame is transmitted, the AP MLD receives another
- * set of 4 packets, which are transmitted after a successful RTS/CTS exchange on a second
- * link. In the meantime, a new RTS/CTS exchange is successfully carried out (on the first
- * link or on the third link) to transmit the first set of 4 packets. When the transmission
- * of the first set of 4 packets starts, the AP MLD receives the third set of 4 packets from
- * the upper layer, which are transmitted after a successful RTS/CTS exchange.
- *
- * This test checks that sequence numbers are correctly assigned to all the MPDUs carrying data.
- */
-class ReleaseSeqNoAfterCtsTimeoutTest : public MultiLinkOperationsTestBase
-{
-  public:
-    ReleaseSeqNoAfterCtsTimeoutTest();
-    ~ReleaseSeqNoAfterCtsTimeoutTest() override = default;
-
-  protected:
-    void DoSetup() override;
-    void DoRun() override;
-    void Transmit(Ptr<WifiMac> mac,
-                  uint8_t phyId,
-                  WifiConstPsduMap psduMap,
-                  WifiTxVector txVector,
-                  double txPowerW) override;
-
-  private:
-    void StartTraffic() override;
-
-    PacketSocketAddress m_sockAddr;   //!< packet socket address
-    std::size_t m_nQosDataFrames;     //!< counter for transmitted QoS data frames
-    Ptr<ListErrorModel> m_errorModel; //!< error rate model to corrupt first RTS frame
-    bool m_rtsCorrupted;              //!< whether the first RTS frame has been corrupted
-};
-
 ReleaseSeqNoAfterCtsTimeoutTest::ReleaseSeqNoAfterCtsTimeoutTest()
     : MultiLinkOperationsTestBase(
           "Check sequence numbers after CTS timeout",
@@ -3219,17 +2811,160 @@
     Simulator::Destroy();
 }
 
-/**
- * \ingroup wifi-test
- * \ingroup tests
- *
- * \brief wifi 11be MLD Test Suite
- */
-class WifiMultiLinkOperationsTestSuite : public TestSuite
+StartSeqNoUpdateAfterAddBaTimeoutTest::StartSeqNoUpdateAfterAddBaTimeoutTest()
+    : MultiLinkOperationsTestBase(
+          "Check starting sequence number update after ADDBA Response timeout",
+          1,
+          BaseParams{{"{36, 0, BAND_5GHZ, 0}", "{1, 0, BAND_6GHZ, 0}"},
+                     {"{36, 0, BAND_5GHZ, 0}", "{1, 0, BAND_6GHZ, 0}"},
+                     {}}),
+      m_nQosDataCount(0),
+      m_staErrorModel(CreateObject<ListErrorModel>())
+{
+}
+
+void
+StartSeqNoUpdateAfterAddBaTimeoutTest::DoSetup()
+{
+    // Enable RTS/CTS by setting a threshold lower than packet size (1000)
+    Config::SetDefault("ns3::WifiRemoteStationManager::RtsCtsThreshold", UintegerValue(900));
+
+    MultiLinkOperationsTestBase::DoSetup();
+
+    // install post reception error model on all STAs affiliated with non-AP MLD
+    for (const auto linkId : m_staMacs[0]->GetLinkIds())
+    {
+        m_staMacs[0]->GetWifiPhy(linkId)->SetPostReceptionErrorModel(m_staErrorModel);
+    }
+}
+
+void
+StartSeqNoUpdateAfterAddBaTimeoutTest::StartTraffic()
+{
+    m_sockAddr.SetSingleDevice(m_apMac->GetDevice()->GetIfIndex());
+    m_sockAddr.SetPhysicalAddress(m_staMacs[0]->GetAddress());
+    m_sockAddr.SetProtocol(1);
+
+    // install client application generating 1 packet of 1000 bytes on the AP MLD
+    m_apMac->GetDevice()->GetNode()->AddApplication(GetApplication(m_sockAddr, 1, 1000));
+}
+
+void
+StartSeqNoUpdateAfterAddBaTimeoutTest::Transmit(Ptr<WifiMac> mac,
+                                                uint8_t phyId,
+                                                WifiConstPsduMap psduMap,
+                                                WifiTxVector txVector,
+                                                double txPowerW)
+{
+    auto psdu = psduMap.begin()->second;
+    const auto& hdr = psdu->GetHeader(0);
+
+    if (hdr.IsAck())
+    {
+        NS_TEST_ASSERT_MSG_EQ(m_txPsdus.empty(), false, "No frame preceding transmitted Ack");
+
+        auto prevPsdu = m_txPsdus.back().psduMap.begin()->second;
+
+        if (prevPsdu->GetHeader(0).IsAction())
+        {
+            WifiActionHeader actionHdr;
+            (*prevPsdu->begin())->GetPacket()->PeekHeader(actionHdr);
+            if (actionHdr.GetCategory() == WifiActionHeader::BLOCK_ACK &&
+                actionHdr.GetAction().blockAck == WifiActionHeader::BLOCK_ACK_ADDBA_REQUEST)
+            {
+                // non-AP MLD is acknowledging the ADDBA Request sent by the AP MLD. When the
+                // AP MLD receives the Ack, it starts an AddBaResponse timer; when the timer
+                // expires, the AP MLD starts sending data frames with normal acknowledgment.
+                // Block transmissions of the non-AP MLD on the link that has to be used to send
+                // the ADDBA Response from now until the end of the timer.
+
+                m_staMacs[0]->BlockUnicastTxOnLinks(WifiQueueBlockedReason::TID_NOT_MAPPED,
+                                                    m_apMac->GetAddress(),
+                                                    {phyId});
+
+                auto band = m_apMac->GetWifiPhy(m_txPsdus.back().linkId)->GetPhyBand();
+                auto ackDuration = WifiPhy::CalculateTxDuration(psduMap, txVector, band);
+
+                // After the AddBaResponse timeout, unblock transmissions of the non-AP MLD on the
+                // link on which the ADDBA Response has to be sent and block transmissions of the
+                // AP MLD on the same link, so that we recreate the situation where the AP MLD sends
+                // the QoS data frame on a link while the non-AP MLD is sending the ADDBA Response
+                // frame on another link.
+                Simulator::Schedule(
+                    ackDuration + m_apMac->GetQosTxop(AC_BE)->GetAddBaResponseTimeout(),
+                    [=, this]() {
+                        m_apMac->BlockUnicastTxOnLinks(WifiQueueBlockedReason::TID_NOT_MAPPED,
+                                                       m_staMacs[0]->GetAddress(),
+                                                       {phyId});
+                        m_staMacs[0]->UnblockUnicastTxOnLinks(
+                            WifiQueueBlockedReason::TID_NOT_MAPPED,
+                            m_apMac->GetAddress(),
+                            {phyId});
+                    });
+            }
+        }
+    }
+
+    MultiLinkOperationsTestBase::Transmit(mac, phyId, psduMap, txVector, txPowerW);
+
+    if (hdr.IsAction())
+    {
+        WifiActionHeader actionHdr;
+        (*psdu->begin())->GetPacket()->PeekHeader(actionHdr);
+        if (actionHdr.GetCategory() == WifiActionHeader::BLOCK_ACK &&
+            actionHdr.GetAction().blockAck == WifiActionHeader::BLOCK_ACK_ADDBA_RESPONSE)
+        {
+            auto band = m_staMacs[0]->GetDevice()->GetPhy(phyId)->GetPhyBand();
+            auto addBaRespDuration = WifiPhy::CalculateTxDuration(psduMap, txVector, band);
+
+            Simulator::Schedule(addBaRespDuration + TimeStep(1), [=, this]() {
+                // After the AP MLD has received the ADDBA Response frame:
+                // - check that the AP has one queued QoS data frame that is in flight
+                auto mpdu = m_apMac->GetTxopQueue(AC_BE)->Peek();
+                NS_TEST_ASSERT_MSG_NE(mpdu, nullptr, "Expected an MPDU in the AP MLD queue");
+                NS_TEST_EXPECT_MSG_EQ(mpdu->GetHeader().IsQosData(),
+                                      true,
+                                      "Expected a QoS data frame");
+                NS_TEST_EXPECT_MSG_EQ(
+                    mpdu->IsInFlight(),
+                    true,
+                    "Expected the data frame to be inflight when ADDBA RESP is received");
+
+                // - check that the starting sequence number at the originator (AP MLD) equals
+                //   the sequence number of the inflight MPDU
+                NS_TEST_EXPECT_MSG_EQ(
+                    m_apMac->GetQosTxop(AC_BE)->GetBaStartingSequence(m_staMacs[0]->GetAddress(),
+                                                                      0),
+                    mpdu->GetHeader().GetSequenceNumber(),
+                    "Unexpected BA Starting Sequence Number");
+            });
+        }
+    }
+    else if (hdr.IsQosData())
+    {
+        // corrupt the reception of the data frame the first time it is sent
+        if (m_nQosDataCount++ == 0)
+        {
+            m_staErrorModel->SetList({psdu->GetPacket()->GetUid()});
+        }
+        else
+        {
+            m_staErrorModel->SetList({});
+        }
+    }
+}
+
+void
+StartSeqNoUpdateAfterAddBaTimeoutTest::DoRun()
 {
-  public:
-    WifiMultiLinkOperationsTestSuite();
-};
+    Simulator::Stop(m_duration);
+    Simulator::Run();
+
+    NS_TEST_EXPECT_MSG_EQ(+m_rxPkts[1], 1, "Unexpected number of packets received by STA 0");
+    NS_TEST_EXPECT_MSG_EQ(m_nQosDataCount, 2, "QoS data frame should be transmitted twice");
+
+    Simulator::Destroy();
+}
 
 WifiMultiLinkOperationsTestSuite::WifiMultiLinkOperationsTestSuite()
     : TestSuite("wifi-mlo", Type::UNIT)
@@ -3242,6 +2977,26 @@
 
     AddTestCase(new GetRnrLinkInfoTest(), TestCase::Duration::QUICK);
     AddTestCase(new MldSwapLinksTest(), TestCase::Duration::QUICK);
+    AddTestCase(
+        new AidAssignmentTest(
+            std::vector<std::set<uint8_t>>{{0, 1, 2}, {1, 2}, {0, 1}, {0, 2}, {0}, {1}, {2}}),
+        TestCase::Duration::QUICK);
+
+    // check that the selection of channels in ML setup accounts for the inability of a
+    // non-AP MLD to operate on a 160 MHz channel
+    AddTestCase(
+        new MultiLinkSetupTest(
+            MultiLinkOperationsTestBase::BaseParams{
+                {"{42, 80, BAND_5GHZ, 2}", "{5, 40, BAND_2_4GHZ, 0}", "{7, 80, BAND_6GHZ, 0}"},
+                {"{3, 40, BAND_2_4GHZ, 0}", "{15, 160, BAND_6GHZ, 7}", "{50, 160, BAND_5GHZ, 2}"},
+                {}},
+            WifiScanType::PASSIVE,
+            {0, 1, 2},
+            WifiTidToLinkMappingNegSupport::ANY_LINK_SET,
+            "",
+            "",
+            false),
+        TestCase::Duration::QUICK);
 
     for (const auto& [baseParams,
                       setupLinks,
@@ -3415,6 +3170,7 @@
     }
 
     AddTestCase(new ReleaseSeqNoAfterCtsTimeoutTest(), TestCase::Duration::QUICK);
+    AddTestCase(new StartSeqNoUpdateAfterAddBaTimeoutTest(), TestCase::Duration::QUICK);
 }
 
 static WifiMultiLinkOperationsTestSuite g_wifiMultiLinkOperationsTestSuite; ///< the test suite
